/*	Time Machine v1.0
 *
 *	Filename:	 time_machine.cpp
 *	Description: Time Machine :)
 *
 *	Have any comments, questions, suggestions, complaints, or anything else?
 *	Email them to me! My email address is bluft@execpc.com.  You can also
 *	reach me on #bedev on EFnet as Electroly.  Have fun!
 *
 *	Copyright (c) 1999, Brian Luft
 */
 
#include <Application.h>
#include <Messenger.h>
#include <MessageRunner.h>

//-------------- Global Constants --------------//
const int32 TM_SWITCH_TIME_BACK = 'TMst';

//-------------- TMApplication --------------//
class TMApplication:public BApplication
{
public:
	TMApplication(void); // Constructor
	~TMApplication(void); // Destructor
	
	virtual void MessageReceived(BMessage*);
};

//-------------- TMApplication Constructor --------------//
TMApplication::TMApplication(void):BApplication("application/x-vnd.brianluft-timemachine")
{
	// Do nothing
};

//-------------- TMApplication Destructor --------------//
TMApplication::~TMApplication(void)
{
	// Do nothing
};

//-------------- TMApplication::MessageReceived --------------//
#include <OS.h>

void TMApplication::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case TM_SWITCH_TIME_BACK:
		{
			// Switch the time back two seconds, because one second has
			// elapsed since last time we set it back :)
			int32 intTime = real_time_clock();
			set_real_time_clock(intTime - 2);
			break;
		}
		default:
		{
			// Pass it on to the inherited MessageReceived
			BApplication::MessageReceived(msg);
			break;
		}
	};
};

//-------------- main() --------------//
#include <Alert.h>

int
main()
{
	// Connect to the app_server
	new TMApplication();
	// Set up the BMessageRunner
	BMessageRunner *myrunner = new BMessageRunner(
		/* BMessenger target */ BMessenger("application/x-vnd.brianluft-timemachine"),
		/* const BMessage *message */ new BMessage(TM_SWITCH_TIME_BACK),
		/* bigtime_t interval */ (bigtime_t)(1 * 1000 * 1000) /* one second */ );
	// Make sure it was created correctly
	if(myrunner->InitCheck() != B_OK)
	{
		// Something is wrong.  Tell the user and quit.
		(new BAlert("Time Machine", "Time Machine error: the BMessageRunner wasn't created correctly.", "Darn"))->Go();
		be_app->Quit();
	};
	// Run the application (sit around and wait until we die)
	be_app->Run();
	// When we're done, kill the be_app and quit
	delete be_app;
	return(0);
};